/***************************************************************************
                          filehandling.cpp  -  description
                             -------------------
    begin                : Sun Jan 28 2001
    copyright            : (C) 2001 by Edwin Schepers
    email                : zeus@castel.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>
#include <errno.h>
#include <sys/stat.h>
#include <unistd.h>

#include <qstring.h>
#include <qmessagebox.h>

#include "filehandling.h"

FileHandling::FileHandling(){
	MP3List = new QList<MP3Entry>();
}
FileHandling::~FileHandling(){
}


QList<MP3Entry> *FileHandling::searchMP3(const char *startpath, bool recursive) {
 DIR *dir;
 struct dirent *ent;
 char Artist[MAXCMTLEN+1], Title[MAXCMTLEN+1], Album[MAXCMTLEN+1], Year[5];
// char text1[MAXCMTLEN+1], text2[MAXCMTLEN+1];
 FILE *fileptr;
 char filename[MAXFILELEN+1];
 char complete_path[MAXFILELEN+1];
 char line[1000+1];
 struct stat buff;
 QString tmpmsg;
 //int retval;
 int TagFound;
 //// why do I have to make it static to let it work ???? I don't understand.
 //static QList<MP3Entry> *MP3List = NULL; //= new QList<MP3Entry>();
 MP3Entry *mp3entry;

//	if ( MP3List != NULL) { // zucht...
//		delete MP3List;
//	}
//	MP3List = new QList<MP3Entry>();

 //printf("in searchMP3()\n");
 if ((dir=opendir(startpath))==NULL) {
  tmpmsg = startpath;
  tmpmsg += " : ";
  tmpmsg += strerror(errno);
//  QMessageBox::warning(this, "Error", tmpmsg);
  //QMessageBox::warning(this, "Error", path + ":" + strerror(errno));
  return NULL;
 }

 while ((ent=readdir(dir)) != NULL) {
   sprintf(complete_path,"%s/%s", startpath, ent->d_name);
   //printf("searchMP3 : examining %s\n", ent->d_name);
   if (isMP3(ent->d_name) == false) { /* the file is not a mp3 file */
     //printf("the file %s is not mp3\n", ent->d_name);
     stat(complete_path, &buff);
     //printf("S_ISLNK returns %d from %s\n", S_ISLNK(buff.st_mode), complete_path);
     if (S_ISDIR(buff.st_mode) && strcmp(ent->d_name,".") &&
          strcmp(ent->d_name,"..")) {
       //printf("S_ISLNK returns %d\n", S_ISLNK(buff.st_mode));
       //printf("'%s' is a dir\n", complete_path);
       if (recursive)
         searchMP3(complete_path, recursive);
       continue;  // take next 'ent' entry
     }
     else
      continue; // take next 'ent' entry
    }

		sprintf(filename, "%s/%s", startpath, ent->d_name);
		//printf("%s\n", filename);
   if ((fileptr=fopen(filename,"r"))==NULL)
   {
    printf("unable to open file %s \n", filename);
    tmpmsg += complete_path;
    //QMessageBox::warning(this, "Error", tmpmsg, 1, 1, 1);
    continue; // take next 'ent' entry
   }

   fseek(fileptr, -128,SEEK_END);
   TagFound = findTAG(fileptr);

//   chkboxInfoFromFname->isChecked()
   strcpy(Artist, "");
   strcpy(Title,"");
   strcpy(Album,"");
   strcpy(Year,"");

   if (TagFound ) {
     fgets(line, 128, fileptr);
     //printf("tag found, complete regel '%s'\n", line);
     strncpy(Title, line, 30);
     Title[30]=0;
     strncpy(Artist, &line[30], 30);
     Artist[30]=0;
     strncpy(Album, &line[2*30], 30);
     Album[30]=0;
     strncpy(Year, &line[3*30], 4);
     Year[4]=0;
     del_trail_spc(Artist);
     del_trail_spc(Title);
     del_trail_spc(Album);
   }

//   if ( (chkboxInfoFromFname->isChecked() && forceFname) ||
//       (!TagFound && chkboxInfoFromFname->isChecked() )) {
//     char RegExp[10];
//     printf("determining info from filename\n");
//     sprintf( RegExp, ".?%s", separator);
//     QRegExp reg(RegExp);
//     int len;
//     if (reg.isValid()==FALSE) printf("regexp not valid\n");
//     int st = reg.match((const char*)ent->d_name, 0, &len);
//     printf("pos=%d, patt=%s, len=%d\n", st, reg.pattern(), len);
//     if (st != -1) { // if st== -1 then it takes the tag (if present) is this wrong?
//       reg.setWildcard (TRUE);
//       printf("ent->dname=%s\n", ent->d_name);
//       strncpy(text1, (char*)ent->d_name, st+1);
//       text1[st+1]=0;
//       int copylen = strlen(ent->d_name) - st/*len of first item*/ - strlen(separator) - 4/* .mp3*/;
//       strncpy(text2,  (char*)&ent->d_name[st+strlen(separator)+1],
//               copylen);
//       text2[copylen-1]=0;
       //printf("text1='%s', text2='%s'\n", text1, text2);
//       if (ArtistPos == 0) {
//         strcpy( Artist, text1);
//         strcpy(Title, text2);
//       }
//      else {
//         strcpy(Title, text1);
//         strcpy(Artist, text2);
//       }
//     }
//   }
//   printf("Artist='%s', Title='%s', Album='%s'\n", Artist, Title, Album);
		mp3entry = new MP3Entry(filename, "HD", Artist, Title, Album, Year);
		MP3List->append(mp3entry);
//printf("after appending\n");
if (MP3List->isEmpty()) printf("and the list is empty\n");		
   //update(); // does it do what I want it to do?
   fclose(fileptr); // close mp3 file

 }
 closedir(dir);
 return MP3List;
}

int FileHandling::findTAG(FILE *fileptr) {
 int i=0;

 while ((i=fgetc(fileptr))!=EOF)
 {
  if (i=='T')
    if ((i=fgetc(fileptr))=='A')
      if ((i=fgetc(fileptr))=='G') {
//        printf("TAG found!\n");
        return 1;
      }
 }
 return 0;
}

void FileHandling::del_trail_spc(char *name) {
 int i;

 i=strlen(name)-1;
 while (name[i] == ' ' ) {
  name[i--] = 0;
 }
}

bool FileHandling::isMP3(char *fname)
{
 if (strlen(fname)<4) return false;
 if ( strstr(&fname[strlen(fname)-4], ".mp3") ||
      strstr(&fname[strlen(fname)-4], ".MP3")) {
  return true;
 }
 return false;
}







