
#ifndef KMP3DBVIEW_H
#define KMP3DBVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>

class Kmp3dbDoc;

/** The Kmp3dbView class provides the view widget for the Kmp3dbApp instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As Kmp3dbView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the Kmp3dbApp class to manipulate and display
 * the document structure provided by the Kmp3dbDoc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class Kmp3dbView : public QWidget
{
  Q_OBJECT
  public:
    /** Constructor for the main view */
    Kmp3dbView(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~Kmp3dbView();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a Kmp3dbApp instance as a parent
     * widget to get to the window document pointer by calling the Kmp3dbApp::getDocument() method.
     *
     * @see Kmp3dbApp#getDocument
     */
    Kmp3dbDoc *getDocument() const;

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);
	
  private:
	
};

#endif // KMP3DBVIEW_H
